package rocks.zipcode.quiz5.fundamentals;

import rocks.zipcode.quiz5.arrays.ArrayUtils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        char[] letters = string.toCharArray();
        return letters[(int)Math.floor(letters.length / 2.0)];
    }

    public static String capitalizeMiddleCharacter(String str) {
        String[] letters = str.split("");
        int index = ArrayUtils.getMiddleIndex(letters);
        for(int i = 0; i < letters.length; i ++){
            if(i == index){
                letters[i] = letters[i].toUpperCase();
            }
        }
        return ArrayUtils.concatToString(letters);
    }

    public static String lowerCaseMiddleCharacter(String str) {
        String[] letters = str.split("");
        int index = ArrayUtils.getMiddleIndex(letters);
        for(int i = 0; i < letters.length; i ++){
            if(i == index){
                letters[i] = letters[i].toLowerCase();
            }
        }
        return ArrayUtils.concatToString(letters);
    }

    public static Boolean isIsogram(String str) {
        String[] letters = str.split("");
        for(int i = 0; i < letters.length; i ++){
            String letter = letters[i];
            for(int j = i + 1; j < letters.length; j ++){
                String letter2 = letters[j];
                if(letter.equals(letter2)){
                    return false;
                }
            }
        }
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        str = str.toLowerCase();
        String[] letters = str.split("");
        String letter = letters[0];
        for(int i = 1; i < letters.length; i ++){
            if(letter.equals(letters[i])){
                return true;
            } else {
                letter = letters[i];
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        String[] letters = str.split("");
        String letter = letters[0];
        for(int i = 1; i < letters.length; i ++){
            if(letter.equals(letters[i])){
                letters[i] = "";
                letters[i - 1] = "";
            } else {
                letter = letters[i];
            }
        }
        return ArrayUtils.concatToString(letters);
    }

    public static String invertCasing(String str) {
        String[] arr = str.split("");
        for(int i = 0; i < arr.length; i ++){
            if(isUpper(arr[i])){
                arr[i] = arr[i].toLowerCase();
            } else {
                arr[i] = arr[i].toUpperCase();
            }
        }
        return ArrayUtils.concatToString(arr);
    }

    public static Boolean isUpper(String s){
        Pattern pattern = Pattern.compile("[A-Z]");
        Matcher matcher = pattern.matcher(s);
        return matcher.find();
    }

}